"use strict";
/*
 *  This file is part of CoCalc: Copyright © 2020 Sagemath, Inc.
 *  License: AGPLv3 s.t. "Commons Clause" – see LICENSE.md for details
 */
Object.defineProperty(exports, "__esModule", { value: true });
var types_1 = require("./types");
types_1.Table({
    name: "account_creation_actions",
    fields: {
        id: {
            type: "uuid",
            desc: "id",
        },
        action: {
            type: "map",
            desc: "Describes the action to carry out when an account is created with the given email_address.",
        },
        email_address: {
            type: "string",
            desc: "Email address of user.",
        },
        expire: {
            type: "timestamp",
            desc: "When this action should be expired.",
        },
    },
    rules: {
        desc: "Actions to carry out when accounts are created, triggered by the email address of the user.",
        primary_key: "id",
        pg_indexes: ["email_address"],
    },
});
