"use strict";
/*
 *  This file is part of CoCalc: Copyright © 2020 Sagemath, Inc.
 *  License: AGPLv3 s.t. "Commons Clause" – see LICENSE.md for details
 */
Object.defineProperty(exports, "__esModule", { value: true });
var types_1 = require("./types");
types_1.Table({
    name: "client_error_log",
    fields: {
        id: {
            type: "uuid",
            desc: "unique identifier for entry (randomly generated)",
        },
        event: { type: "string", desc: "arbitrary event label" },
        error: { type: "string", desc: "the actual error message user saw" },
        account_id: { type: "uuid", desc: "the account_id of the user" },
        time: { type: "timestamp", desc: "when user saw the error" },
        expire: {
            type: "timestamp",
            desc: "when to delete this error automatically from the table to save space",
        },
    },
    rules: {
        desc: "Table used to log errors that clients see in their web browser.",
        primary_key: "id",
        durability: "soft",
        pg_indexes: ["time", "event"],
    },
});
