"use strict";
/*
 *  This file is part of CoCalc: Copyright © 2020 Sagemath, Inc.
 *  License: AGPLv3 s.t. "Commons Clause" – see LICENSE.md for details
 */
Object.defineProperty(exports, "__esModule", { value: true });
var types_1 = require("./types");
types_1.Table({
    name: "file_access_log",
    rules: {
        primary_key: "id",
        durability: "soft",
        pg_indexes: ["project_id", "account_id", "filename", "time"],
    },
    fields: {
        id: {
            type: "uuid",
        },
        project_id: {
            type: "uuid",
        },
        account_id: {
            type: "uuid",
        },
        filename: {
            type: "string",
        },
        time: {
            type: "timestamp",
        },
    },
});
