"use strict";
/*
 *  This file is part of CoCalc: Copyright © 2020 Sagemath, Inc.
 *  License: AGPLv3 s.t. "Commons Clause" – see LICENSE.md for details
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.client_db = exports.site_settings_conf = exports.FALLBACK_COMPUTE_IMAGE = exports.DEFAULT_COMPUTE_IMAGE = exports.DEFAULT_NEW_FILENAMES = exports.NEW_FILENAMES = exports.DEFAULT_FONT_SIZE = exports.SCHEMA = void 0;
var types_1 = require("./types");
Object.defineProperty(exports, "SCHEMA", { enumerable: true, get: function () { return types_1.SCHEMA; } });
// The tables
require("./account-creation-actions");
require("./account-profiles");
require("./accounts");
require("./auth");
require("./blobs");
require("./client-error-log");
require("./central-log");
require("./collaborators");
require("./compute-images");
require("./compute-servers");
require("./copy-paths");
require("./file-access-log");
require("./file-use");
require("./file-use-times");
require("./hub-servers");
require("./instances"); // probably deprecated
require("./listings");
require("./lti");
require("./mentions");
require("./password-reset");
require("./project-info");
require("./project-log");
require("./project-status");
require("./projects");
require("./public-paths");
require("./project-invite-tokens");
require("./registration-tokens");
require("./server-settings");
require("./site-licenses");
require("./site-settings");
require("./stats");
require("./storage-servers");
require("./system-notifications");
require("./tracking");
require("./usage-info");
require("./webapp-errors");
require("./site-whitelabeling");
var defaults_1 = require("./defaults");
Object.defineProperty(exports, "DEFAULT_FONT_SIZE", { enumerable: true, get: function () { return defaults_1.DEFAULT_FONT_SIZE; } });
Object.defineProperty(exports, "NEW_FILENAMES", { enumerable: true, get: function () { return defaults_1.NEW_FILENAMES; } });
Object.defineProperty(exports, "DEFAULT_NEW_FILENAMES", { enumerable: true, get: function () { return defaults_1.DEFAULT_NEW_FILENAMES; } });
Object.defineProperty(exports, "DEFAULT_COMPUTE_IMAGE", { enumerable: true, get: function () { return defaults_1.DEFAULT_COMPUTE_IMAGE; } });
Object.defineProperty(exports, "FALLBACK_COMPUTE_IMAGE", { enumerable: true, get: function () { return defaults_1.FALLBACK_COMPUTE_IMAGE; } });
var site_defaults_1 = require("./site-defaults");
Object.defineProperty(exports, "site_settings_conf", { enumerable: true, get: function () { return site_defaults_1.site_settings_conf; } });
var client_db_1 = require("./client-db");
Object.defineProperty(exports, "client_db", { enumerable: true, get: function () { return client_db_1.client_db; } });
