"use strict";
/*
 *  This file is part of CoCalc: Copyright © 2020 Sagemath, Inc.
 *  License: AGPLv3 s.t. "Commons Clause" – see LICENSE.md for details
 */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
// An account token is a piece of additional information,
// which might be necessary to create an account.
// In the future, this might be extended to dispatch some action,
// like adding a student to a course, similar to account creation actions.
var types_1 = require("./types");
var async_utils_1 = require("smc-util/async-utils");
function is_delete(options) {
    return options.some(function (v) { return (v === null || v === void 0 ? void 0 : v.delete) === true; });
}
// this covers 3 cases: selecting all, updating one, and deleting one
function instead_of_query(db, opts, cb) {
    return __awaiter(this, void 0, void 0, function () {
        var options, query, data, token, descr, expires, limit, disabled, err_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    options = opts.options, query = opts.query;
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 9, , 10]);
                    if (!(is_delete(options) && query.token)) return [3 /*break*/, 3];
                    // delete if option is set and there is a token which is defined and not an empty string
                    return [4 /*yield*/, async_utils_1.callback2(db._query, {
                            query: "DELETE FROM registration_tokens WHERE token = $1",
                            params: [query.token],
                        })];
                case 2:
                    // delete if option is set and there is a token which is defined and not an empty string
                    _a.sent();
                    cb(null);
                    return [3 /*break*/, 8];
                case 3:
                    if (!(query.token == "*")) return [3 /*break*/, 5];
                    return [4 /*yield*/, async_utils_1.callback2(db._query, {
                            query: "SELECT * FROM registration_tokens",
                        })];
                case 4:
                    data = _a.sent();
                    cb(null, data.rows);
                    return [3 /*break*/, 8];
                case 5:
                    if (!(query.token != null && query.token != "")) return [3 /*break*/, 7];
                    token = query.token, descr = query.descr, expires = query.expires, limit = query.limit, disabled = query.disabled;
                    return [4 /*yield*/, async_utils_1.callback2(db._query, {
                            query: "INSERT INTO registration_tokens (\"token\",\"descr\",\"expires\",\"limit\",\"disabled\")\n                  VALUES ($1, $2, $3, $4, $5) ON CONFLICT (token)\n                  DO UPDATE SET\n                    \"token\"    = EXCLUDED.token,\n                    \"descr\"    = EXCLUDED.descr,\n                    \"expires\"  = EXCLUDED.expires,\n                    \"limit\"    = EXCLUDED.limit,\n                    \"disabled\" = EXCLUDED.disabled",
                            params: [
                                token,
                                descr ? descr : null,
                                expires ? expires : null,
                                limit >= 0 ? limit : null,
                                disabled != null ? disabled : false,
                            ],
                        })];
                case 6:
                    _a.sent();
                    cb(null);
                    return [3 /*break*/, 8];
                case 7: throw new Error("don't know what to do with this query");
                case 8: return [3 /*break*/, 10];
                case 9:
                    err_1 = _a.sent();
                    cb(err_1);
                    return [3 /*break*/, 10];
                case 10: return [2 /*return*/];
            }
        });
    });
}
types_1.Table({
    name: "registration_tokens",
    rules: {
        primary_key: "token",
        anonymous: false,
        user_query: {
            set: {
                admin: true,
                instead_of_query: instead_of_query,
                delete: true,
                fields: {
                    token: null,
                    descr: null,
                    expires: null,
                    limit: null,
                    disabled: null,
                },
            },
            get: {
                admin: true,
                instead_of_query: instead_of_query,
                pg_where: [],
                fields: {
                    token: null,
                    descr: null,
                    expires: null,
                    counter: null,
                    limit: null,
                    disabled: null,
                },
            },
        },
    },
    fields: {
        token: { type: "string" },
        descr: { type: "string" },
        counter: { type: "number", desc: "how many accounts are created" },
        expires: {
            type: "timestamp",
            desc: "optional – the time, when this token is no longer valid",
        },
        limit: { type: "number", desc: "optional – maximum number of accounts" },
        disabled: { type: "boolean", desc: "set to true to disable this token" },
    },
});
