"use strict";
/*
 *  This file is part of CoCalc: Copyright © 2020 Sagemath, Inc.
 *  License: AGPLv3 s.t. "Commons Clause" – see LICENSE.md for details
 */
Object.defineProperty(exports, "__esModule", { value: true });
var types_1 = require("./types");
types_1.Table({
    name: "passport_settings",
    rules: {
        primary_key: "strategy",
    },
    fields: {
        strategy: {
            type: "string",
        },
        conf: {
            type: "map",
        },
    },
});
types_1.Table({
    name: "server_settings",
    rules: {
        primary_key: "name",
        anonymous: false,
        user_query: {
            // NOTE: can *set* but cannot get!
            set: {
                admin: true,
                fields: {
                    name: null,
                    value: null,
                },
            },
        },
    },
    fields: {
        name: {
            type: "string",
        },
        value: {
            type: "string",
        },
    },
});
