"use strict";
/*
 *  This file is part of CoCalc: Copyright © 2020 Sagemath, Inc.
 *  License: AGPLv3 s.t. "Commons Clause" – see LICENSE.md for details
 */
Object.defineProperty(exports, "__esModule", { value: true });
// These site-settings are visible to any user (read-only)
// They contain information like the site's name, contact email addresses, etc.
var site_defaults_1 = require("./site-defaults");
var site_settings_extras_1 = require("./site-settings-extras");
var misc_1 = require("../misc");
var site_settings_fields = misc_1.keys(site_defaults_1.site_settings_conf).concat(misc_1.keys(site_settings_extras_1.EXTRAS));
var types_1 = require("./types");
types_1.Table({
    name: "site_settings",
    rules: {
        virtual: "server_settings",
        anonymous: false,
        user_query: {
            // NOTE: can set and get only fields in site_settings_fields, but not any others.
            get: {
                pg_where: [{ "name = ANY($)": site_settings_fields }],
                admin: true,
                fields: {
                    name: null,
                    value: null,
                },
            },
            set: {
                admin: true,
                fields: {
                    name: function (obj, _db) {
                        if (site_settings_fields.includes(obj.name)) {
                            return obj.name;
                        }
                        throw Error("setting name='" + obj.name + "' not allowed");
                    },
                    value: null,
                },
            },
        },
    },
});
