"use strict";
/*
 *  This file is part of CoCalc: Copyright © 2020 Sagemath, Inc.
 *  License: AGPLv3 s.t. "Commons Clause" – see LICENSE.md for details
 */
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.move_file_variations = exports.deleted_file_variations = void 0;
var misc_1 = require("./misc");
// NOTE: there are also .term files in subframes with history that doesn't get
// deleted.  That's an edge case.
// This *includes* path.
function deleted_file_variations(path) {
    var e_1, _a;
    var _b = misc_1.path_split(path), head = _b.head, tail = _b.tail;
    if (head != "") {
        head = head + "/";
    }
    var variations = [path];
    try {
        for (var _c = __values([
            "sage-chat",
            "sage-jupyter",
            "sage-jupyter2",
            "time-travel",
            "sage-history",
            "syncdb",
        ]), _d = _c.next(); !_d.done; _d = _c.next()) {
            var ext = _d.value;
            variations.push(head + "." + tail + "." + ext);
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return variations;
}
exports.deleted_file_variations = deleted_file_variations;
// This does NOT include {src,dest}.
function move_file_variations(src, dest) {
    var e_2, _a;
    var _b = misc_1.path_split(src), head = _b.head, tail = _b.tail;
    if (head != "") {
        head = head + "/";
    }
    var d = misc_1.path_split(dest);
    if (d.head != "") {
        d.head = d.head + "/";
    }
    var variations = [];
    try {
        for (var _c = __values([
            "sage-chat",
            "sage-jupyter",
            "sage-jupyter2",
            "time-travel",
            "sage-history",
        ]), _d = _c.next(); !_d.done; _d = _c.next()) {
            var ext = _d.value;
            variations.push({
                src: head + "." + tail + "." + ext,
                dest: d.head + "." + d.tail + "." + ext,
            });
        }
    }
    catch (e_2_1) { e_2 = { error: e_2_1 }; }
    finally {
        try {
            if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
        }
        finally { if (e_2) throw e_2.error; }
    }
    return variations;
}
exports.move_file_variations = move_file_variations;
