"use strict";
/*
 *  This file is part of CoCalc: Copyright © 2020 Sagemath, Inc.
 *  License: AGPLv3 s.t. "Commons Clause" – see LICENSE.md for details
 */
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.wrap_log = exports.log = exports.get_uptime = exports.get_start_time_ts = void 0;
var misc_1 = require("./misc");
var smc_logger_timestamp, smc_logger_timestamp_last, smc_start_time;
smc_logger_timestamp = smc_logger_timestamp_last = smc_start_time =
    new Date().getTime() / 1000.0;
var get_start_time_ts = function () { return new Date(smc_start_time * 1000); };
exports.get_start_time_ts = get_start_time_ts;
var get_uptime = function () {
    return misc_1.seconds2hms(new Date().getTime() / 1000.0 - smc_start_time);
};
exports.get_uptime = get_uptime;
function log() {
    var _a, _b;
    var _args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        _args[_i] = arguments[_i];
    }
    smc_logger_timestamp = new Date().getTime() / 1000.0;
    var t = misc_1.seconds2hms(smc_logger_timestamp - smc_start_time);
    var dt = misc_1.seconds2hms(smc_logger_timestamp - smc_logger_timestamp_last);
    // support for string interpolation for the actual console.log
    var _c = __read(Array.from(Array.prototype.slice.call(arguments))), msg = _c[0], args = _c.slice(1);
    var prompt = "[" + t + " \u0394 " + dt + "]";
    if (typeof msg == "string") {
        prompt = prompt + " " + msg;
        (_a = console).log_original.apply(_a, __spread([prompt], Array.from(args)));
    }
    else {
        (_b = console).log_original.apply(_b, __spread([prompt, msg], Array.from(args)));
    }
    smc_logger_timestamp_last = smc_logger_timestamp;
}
exports.log = log;
function wrap_log() {
    if (!misc_1.RUNNING_IN_NODE && typeof window != "undefined") {
        window.console.log_original = window.console.log;
        window.console.log = log;
    }
}
exports.wrap_log = wrap_log;
