"use strict";
/*
 *  This file is part of CoCalc: Copyright © 2020 Sagemath, Inc.
 *  License: AGPLv3 s.t. "Commons Clause" – see LICENSE.md for details
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.math_unescape = exports.math_escape = void 0;
/*
 * license
 */
var misc_1 = require("./misc");
var escape_map = "$";
// We used to do this since we wanted to support math delineated by \[ ... \];
// however, that just conflicts too much with markdown itself and Jupyter classic
// doesn't do it.  Use $ only.
//const escape_map = "$()[]";
var unescape_map = "\uFE22\uFE23\uFE24\uFE25\uFE26"; /* we just use some unallocated unicode... */
function math_escape(s) {
    for (var i = 0; i < escape_map.length; i++) {
        s = misc_1.replace_all(s, "\\" + escape_map[i], unescape_map[i]);
    }
    return s;
}
exports.math_escape = math_escape;
function math_unescape(s) {
    for (var i = 0; i < escape_map.length; i++) {
        s = misc_1.replace_all(s, unescape_map[i], "\\" + escape_map[i]);
    }
    return s;
}
exports.math_unescape = math_unescape;
