"use strict";
/*
 *  This file is part of CoCalc: Copyright © 2020 Sagemath, Inc.
 *  License: AGPLv3 s.t. "Commons Clause" – see LICENSE.md for details
 */
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.apply_without_math = void 0;
/*
Additional mathjax utilities.
*/
var mathjax_utils_1 = require("./mathjax-utils");
var misc_1 = require("./misc");
// string -- a string
// v -- either a single function or an array of functions
// First strips out math, applies all the functions, then puts the math back.
function apply_without_math(string, v) {
    var _a, e_1, _b;
    var math;
    if (!misc_1.is_array(v)) {
        v = [v];
    }
    _a = __read(mathjax_utils_1.remove_math(string), 2), string = _a[0], math = _a[1];
    try {
        for (var v_1 = __values(v), v_1_1 = v_1.next(); !v_1_1.done; v_1_1 = v_1.next()) {
            var f = v_1_1.value;
            string = f(string);
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (v_1_1 && !v_1_1.done && (_b = v_1.return)) _b.call(v_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return mathjax_utils_1.replace_math(string, math);
}
exports.apply_without_math = apply_without_math;
