"use strict";
/*
 *  This file is part of CoCalc: Copyright © 2020 Sagemath, Inc.
 *  License: AGPLv3 s.t. "Commons Clause" – see LICENSE.md for details
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.DEFAULT_QUOTAS = exports.RECENT_TIMES_KEY = exports.RECENT_TIMES = void 0;
// This file is purely to give HtmlWebpackPlugin an opportunity to pick up these const values
// In any other place, import from the main schema file
// these times in minutes are used for active/recently edited projects and accounts in postgres-server-queries.coffee's get_stats
exports.RECENT_TIMES = Object.freeze({
    active: 5,
    last_hour: 60,
    last_day: 60 * 24,
    last_week: 60 * 24 * 7,
    last_month: 60 * 24 * 30,
});
// this translates the semantic meanings to the keys used in the DB, also prevents typos!
exports.RECENT_TIMES_KEY = Object.freeze({
    active: "5min",
    last_hour: "1h",
    last_day: "1d",
    last_week: "7d",
    last_month: "30d",
});
var upgrade_spec_1 = require("./upgrade-spec");
Object.defineProperty(exports, "DEFAULT_QUOTAS", { enumerable: true, get: function () { return upgrade_spec_1.DEFAULT_QUOTAS; } });
