"use strict";
/*
 *  This file is part of CoCalc: Copyright © 2020 Sagemath, Inc.
 *  License: AGPLv3 s.t. "Commons Clause" – see LICENSE.md for details
 */
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.export_history = void 0;
function export_history(account_ids, patch_list, options) {
    var e_1, _a;
    var patches = patch_list.export();
    var entries = [];
    try {
        for (var patches_1 = __values(patches), patches_1_1 = patches_1.next(); !patches_1_1.done; patches_1_1 = patches_1.next()) {
            var x = patches_1_1.value;
            var time_utc = x.time;
            var account_id = account_ids[x.user_id];
            if (account_id == null) {
                account_id = "unknown"; // should never happen...
            }
            var entry = { time_utc: time_utc, account_id: account_id };
            if (options.patches) {
                entry.patch = x.patch;
            }
            if (options.patch_lengths) {
                entry.patch_length = JSON.stringify(x.patch).length;
            }
            entries.push(entry);
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (patches_1_1 && !patches_1_1.done && (_a = patches_1.return)) _a.call(patches_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return entries;
}
exports.export_history = export_history;
