"use strict";
/*
 *  This file is part of CoCalc: Copyright © 2020 Sagemath, Inc.
 *  License: AGPLv3 s.t. "Commons Clause" – see LICENSE.md for details
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IpywidgetsState = void 0;
var events_1 = require("events");
var misc_1 = require("../../../misc");
var IpywidgetsState = /** @class */ (function (_super) {
    __extends(IpywidgetsState, _super);
    function IpywidgetsState(syncdoc, client, create_synctable) {
        var _this = _super.call(this) || this;
        _this.state = "init";
        _this.table_options = [];
        // If capture_output[msg_id] is defined, then
        // all output with that msg_id is captured by the
        // widget with given model_id.   This data structure
        // is ONLY used in the project, and is not synced
        // between frontends and project.
        _this.capture_output = {};
        // If the next output should be cleared.  Use for
        // clear_output with wait=true.
        _this.clear_output = {};
        _this.syncdoc = syncdoc;
        _this.client = client;
        _this.create_synctable = create_synctable;
        if (_this.syncdoc.data_server == "project") {
            // options only supported for project...
            // ephemeral -- don't store longterm in database
            // persistent -- doesn't automatically vanish when all browser clients disconnect
            _this.table_options = [{ ephemeral: true, persistent: true }];
        }
        return _this;
    }
    IpywidgetsState.prototype.init = function () {
        return __awaiter(this, void 0, void 0, function () {
            var query, _a;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        query = {
                            ipywidgets: [
                                {
                                    string_id: this.syncdoc.get_string_id(),
                                    model_id: null,
                                    type: null,
                                    data: null,
                                },
                            ],
                        };
                        _a = this;
                        return [4 /*yield*/, this.create_synctable(query, this.table_options, 0)];
                    case 1:
                        _a.table = _b.sent();
                        // TODO: here the project should clear the table.
                        this.set_state("ready");
                        this.table.on("change", function (keys) {
                            _this.emit("change", keys);
                        });
                        return [2 /*return*/];
                }
            });
        });
    };
    IpywidgetsState.prototype.keys = function () {
        // return type is immutable js iterator
        this.assert_state("ready");
        var x = this.table.get();
        if (x == null) {
            return [];
        }
        else {
            return x.keys();
        }
    };
    IpywidgetsState.prototype.get = function (model_id, type) {
        var key = JSON.stringify([
            this.syncdoc.get_string_id(),
            model_id,
            type,
        ]);
        var record = this.table.get(key);
        if (record == null) {
            return undefined;
        }
        return record.get("data");
    };
    // assembles together state we know about the widget with given model_id
    // from info in the table, and returns it as a Javascript object.
    IpywidgetsState.prototype.get_model_state = function (model_id) {
        this.assert_state("ready");
        var state = this.get(model_id, "state");
        if (state == null) {
            return undefined;
        }
        var state_js = state.toJS();
        var value = this.get(model_id, "value");
        if (value != null) {
            value = value.toJS();
            if (value == null) {
                throw Error("value must be a map");
            }
            for (var key in value) {
                state_js[key] = value[key];
            }
        }
        return state_js;
    };
    IpywidgetsState.prototype.get_model_value = function (model_id) {
        this.assert_state("ready");
        var value = this.get(model_id, "value");
        if (value == null) {
            return {};
        }
        value = value.toJS();
        if (value == null) {
            return {};
        }
        return value;
    };
    IpywidgetsState.prototype.get_model_buffers = function (model_id) {
        var value = this.get(model_id, "buffers");
        if (value == null) {
            return { buffer_paths: [], buffers: [] };
        }
        value = value.toJS();
        if (value == null) {
            return { buffer_paths: [], buffers: [] };
        }
        if (value.buffer_paths == null) {
            value.buffer_paths = [];
        }
        if (value.buffers == null) {
            value.buffers = [];
        }
        return value;
    };
    IpywidgetsState.prototype.set_model_value = function (model_id, value, fire_change_event) {
        if (fire_change_event === void 0) { fire_change_event = true; }
        this.set(model_id, "value", value, fire_change_event);
    };
    IpywidgetsState.prototype.set_model_buffers = function (model_id, buffer_paths, buffers, fire_change_event) {
        if (fire_change_event === void 0) { fire_change_event = true; }
        // const dbg = this.dbg("set_model_buffers");
        // dbg("buffer_paths = ", buffer_paths);
        // dbg("buffers=", buffers);
        // TODO: this is very inefficient for now since it just sends
        // the binary data via JSON + websocket.  Instead, I guess we
        // could use HTTP?
        this.set(model_id, "buffers", { buffer_paths: buffer_paths, buffers: buffers }, fire_change_event);
    };
    IpywidgetsState.prototype.set_model_state = function (model_id, state, fire_change_event) {
        if (fire_change_event === void 0) { fire_change_event = true; }
        this.set(model_id, "state", state, fire_change_event);
    };
    // Do any setting of the underlying table through this function.
    IpywidgetsState.prototype.set = function (model_id, type, data, fire_change_event) {
        if (fire_change_event === void 0) { fire_change_event = true; }
        var string_id = this.syncdoc.get_string_id();
        if (typeof data != "object") {
            throw Error("TypeError -- data must be a map");
        }
        var merge;
        if (type == "value") {
            // we manually do the shallow merge only on the data field.
            var data0 = this.get_model_value(model_id);
            if (data0 != null) {
                for (var k in data) {
                    data0[k] = data[k];
                }
                data = data0;
            }
            merge = "none";
        }
        else {
            merge = "deep";
        }
        this.table.set({ string_id: string_id, type: type, model_id: model_id, data: data }, merge, fire_change_event);
    };
    IpywidgetsState.prototype.save = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.table.save()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    IpywidgetsState.prototype.close = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(this.table != null)) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.table.close()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        misc_1.close(this);
                        this.set_state("closed");
                        return [2 /*return*/];
                }
            });
        });
    };
    IpywidgetsState.prototype.dbg = function (_f) {
        if (this.client.is_project() || true) {
            // TODO
            return this.client.dbg("IpywidgetsState." + _f);
        }
        else {
            return function () {
                var _ = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    _[_i] = arguments[_i];
                }
            };
        }
    };
    IpywidgetsState.prototype.clear = function () {
        return __awaiter(this, void 0, void 0, function () {
            var dbg;
            return __generator(this, function (_a) {
                // TODO -- delete everything from table.
                // This is needed when we restart the kernel.
                this.assert_state("ready");
                dbg = this.dbg("clear");
                dbg("NOT IMPLEMENTED");
                return [2 /*return*/];
            });
        });
    };
    // The finite state machine state, e.g., 'init' --> 'ready' --> 'close'
    IpywidgetsState.prototype.set_state = function (state) {
        this.state = state;
    };
    IpywidgetsState.prototype.get_state = function () {
        return this.state;
    };
    IpywidgetsState.prototype.assert_state = function (state) {
        if (this.state != state) {
            throw Error("state must be \"" + state + "\" but it is \"" + this.state + "\"");
        }
    };
    /*
    process_comm_message_from_kernel gets called whenever the
    kernel emits a comm
    message related to widgets.  This updates the state of the
    table, which results in frontends creating or updating
    widgets.
    */
    IpywidgetsState.prototype.process_comm_message_from_kernel = function (msg) {
        return __awaiter(this, void 0, void 0, function () {
            var dbg, content, comm_id, model_id, data, state, msg_id, parent_msg_id, v, w, w_1, w_1_1, m;
            var e_1, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        dbg = this.dbg("process_comm_message_from_kernel");
                        dbg(JSON.stringify(msg));
                        this.assert_state("ready");
                        content = msg.content;
                        if (content == null) {
                            dbg("content is null -- ignoring message");
                            return [2 /*return*/];
                        }
                        comm_id = content.comm_id;
                        if (comm_id == null) {
                            if (msg.header != null) {
                                comm_id = msg.header.msg_id;
                            }
                            if (comm_id == null) {
                                dbg("comm_id is null -- ignoring message");
                                return [2 /*return*/];
                            }
                        }
                        model_id = comm_id;
                        dbg("model_id=" + model_id);
                        data = content.data;
                        if (data == null) {
                            dbg("content.data is null -- ignoring message");
                            return [2 /*return*/];
                        }
                        state = data.state;
                        if (state == null) {
                            dbg("state is null -- ignoring message");
                            return [2 /*return*/];
                        }
                        misc_1.delete_null_fields(state);
                        switch (content.data.method) {
                            case "update":
                                dbg("method -- update");
                                if (state != null) {
                                    if (this.clear_output[model_id] && state.outputs != null) {
                                        // we are supposed to clear the output before inserting
                                        // the next output.
                                        dbg("clearing outputs");
                                        if (state.outputs.length > 0) {
                                            state.outputs = [state.outputs[state.outputs.length - 1]];
                                        }
                                        else {
                                            state.outputs = [];
                                        }
                                        delete this.clear_output[model_id];
                                    }
                                    this.set_model_value(model_id, state, false);
                                }
                                if (state.msg_id != null) {
                                    msg_id = state.msg_id;
                                    if (typeof msg_id === "string" && msg_id.length > 0) {
                                        dbg("enabling capture output", msg_id, model_id);
                                        if (this.capture_output[msg_id] == null) {
                                            this.capture_output[msg_id] = [model_id];
                                        }
                                        else {
                                            // pushing onto stack
                                            this.capture_output[msg_id].push(model_id);
                                        }
                                    }
                                    else {
                                        parent_msg_id = msg.parent_header.msg_id;
                                        dbg("disabling capture output", parent_msg_id, model_id);
                                        if (this.capture_output[parent_msg_id] != null) {
                                            v = [];
                                            w = this.capture_output[parent_msg_id];
                                            try {
                                                for (w_1 = __values(w), w_1_1 = w_1.next(); !w_1_1.done; w_1_1 = w_1.next()) {
                                                    m = w_1_1.value;
                                                    if (m != model_id) {
                                                        v.push(m);
                                                    }
                                                }
                                            }
                                            catch (e_1_1) { e_1 = { error: e_1_1 }; }
                                            finally {
                                                try {
                                                    if (w_1_1 && !w_1_1.done && (_a = w_1.return)) _a.call(w_1);
                                                }
                                                finally { if (e_1) throw e_1.error; }
                                            }
                                            if (v.length == 0) {
                                                delete this.capture_output[parent_msg_id];
                                            }
                                            else {
                                                this.capture_output[parent_msg_id] = v;
                                            }
                                        }
                                    }
                                    delete state.msg_id;
                                }
                                if (misc_1.len(state) > 0) {
                                    this.set_model_state(model_id, state, false);
                                }
                                break;
                            case undefined:
                                dbg("method -- undefined (=initial set?)");
                                this.set_model_state(model_id, state, false);
                                break;
                            default:
                                // TODO: Implement other methods, e.g., 'display' -- see
                                // https://github.com/jupyter-widgets/ipywidgets/blob/master/packages/schema/messages.md
                                dbg("not implemented method '" + content.data.method + "' -- ignoring");
                        }
                        if (content.data.buffer_paths != null &&
                            content.data.buffer_paths.length > 0) {
                            // We have to deal with binary buffers...
                            this.set_model_buffers(model_id, content.data.buffer_paths, msg.buffers, false);
                        }
                        return [4 /*yield*/, this.save()];
                    case 1:
                        _b.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /*
    process_comm_message_from_widget gets called whenever a
    browser client emits a comm message related to widgets.
    This updates the state of the table, which results in
    other frontends updating their widget state, *AND* the backend
    kernel changing the value of variables (and possibly
    updating other widgets).
    */
    IpywidgetsState.prototype.process_comm_message_from_browser = function (msg) {
        return __awaiter(this, void 0, void 0, function () {
            var dbg;
            return __generator(this, function (_a) {
                dbg = this.dbg("process_comm_message_from_browser");
                dbg(msg);
                this.assert_state("ready");
                return [2 /*return*/];
            });
        });
    };
    // The mesg here is exactly what came over the IOPUB channel
    // from the kernel.
    // TODO: deal with buffers
    IpywidgetsState.prototype.capture_output_message = function (mesg) {
        var msg_id = mesg.parent_header.msg_id;
        if (this.capture_output[msg_id] == null) {
            return false;
        }
        var dbg = this.dbg("capture_output_message");
        dbg(JSON.stringify(mesg));
        var model_id = this.capture_output[msg_id][this.capture_output[msg_id].length - 1];
        if (model_id == null)
            return false; // should not happen.
        if (mesg.header.msg_type == "clear_output") {
            if (mesg.content != null && mesg.content.wait) {
                this.clear_output[model_id] = true;
            }
            else {
                delete this.clear_output[model_id];
                this.set_model_value(model_id, { outputs: [] });
            }
            return true;
        }
        if (mesg.content == null || misc_1.len(mesg.content) == 0) {
            // no actual content.
            return false;
        }
        var outputs;
        if (this.clear_output[model_id]) {
            delete this.clear_output[model_id];
            outputs = [];
        }
        else {
            outputs = this.get_model_value(model_id).outputs;
            if (outputs == null) {
                outputs = [];
            }
        }
        outputs.push(mesg.content);
        this.set_model_value(model_id, { outputs: outputs });
        return true;
    };
    return IpywidgetsState;
}(events_1.EventEmitter));
exports.IpywidgetsState = IpywidgetsState;
