"use strict";
/*
 *  This file is part of CoCalc: Copyright © 2020 Sagemath, Inc.
 *  License: AGPLv3 s.t. "Commons Clause" – see LICENSE.md for details
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Client = exports.FileWatcher = void 0;
/*
Minimal client class that we use for testing.
*/
var events_1 = require("events");
var misc_1 = require("../../../../misc");
var async_utils_1 = require("../../../../async-utils");
var synctable_1 = require("../../../table/synctable");
var FileWatcher = /** @class */ (function (_super) {
    __extends(FileWatcher, _super);
    function FileWatcher(path) {
        var _this = _super.call(this) || this;
        _this.path = path;
        console.log("FileWatcher", _this.path);
        return _this;
    }
    FileWatcher.prototype.close = function () { };
    return FileWatcher;
}(events_1.EventEmitter));
exports.FileWatcher = FileWatcher;
var Client = /** @class */ (function (_super) {
    __extends(Client, _super);
    function Client(initial_get_query, client_id) {
        var _this = _super.call(this) || this;
        _this.set_queries = [];
        _this._client_id = client_id;
        _this.initial_get_query = initial_get_query;
        misc_1.bind_methods(_this, ["query", "dbg", "query_cancel"]);
        return _this;
    }
    Client.prototype.server_time = function () {
        return new Date();
    };
    Client.prototype.is_user = function () {
        return true;
    };
    Client.prototype.is_project = function () {
        return false;
    };
    Client.prototype.dbg = function (_f) {
        return function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            console.log.apply(console, __spread([_f], args));
        };
        //return (..._) => {};
    };
    Client.prototype.mark_file = function (_opts) {
        //console.log("mark_file", opts);
    };
    Client.prototype.log_error = function (opts) {
        console.log("log_error", opts);
    };
    Client.prototype.query = function (opts) {
        var _a;
        if (opts.options && opts.options.length === 1 && opts.options[0].set) {
            // set query
            this.set_queries.push(opts);
            opts.cb();
        }
        else {
            // get query -- returns predetermined result
            var table = misc_1.keys(opts.query)[0];
            var result = this.initial_get_query[table];
            if (result == null) {
                result = [];
            }
            //console.log("GET QUERY ", table, result);
            opts.cb(undefined, { query: (_a = {}, _a[table] = result, _a) });
        }
    };
    Client.prototype.path_access = function (opts) {
        console.log("path_access", opts.path, opts.mode);
        opts.cb(true);
    };
    Client.prototype.path_exists = function (opts) {
        console.log("path_access", opts.path);
        opts.cb(true);
    };
    Client.prototype.path_stat = function (opts) {
        console.log("path_state", opts.path);
        opts.cb(true);
    };
    Client.prototype.path_read = function (opts) {
        console.log("path_ready", opts.path);
        opts.cb(true);
    };
    Client.prototype.write_file = function (opts) {
        console.log("write_file", opts.path, opts.data);
        opts.cb(true);
    };
    Client.prototype.watch_file = function (opts) {
        return new FileWatcher(opts.path);
    };
    Client.prototype.is_connected = function () {
        return true;
    };
    Client.prototype.is_signed_in = function () {
        return true;
    };
    Client.prototype.touch_project = function (_) { };
    Client.prototype.query_cancel = function (_) { };
    Client.prototype.alert_message = function (_) { };
    Client.prototype.is_deleted = function (_filename, _project_id) {
        return false;
    };
    Client.prototype.set_deleted = function (_filename, _project_id) { };
    Client.prototype.synctable_project = function (_project_id, query, options, throttle_changes) {
        return __awaiter(this, void 0, void 0, function () {
            var s;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        s = new synctable_1.SyncTable(query, options, this, throttle_changes);
                        return [4 /*yield*/, async_utils_1.once(s, "connected")];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, s];
                }
            });
        });
    };
    Client.prototype.synctable_database = function (_query, _options, _throttle_changes) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                throw Error("not implemented");
            });
        });
    };
    // account_id or project_id
    Client.prototype.client_id = function () {
        return this._client_id;
    };
    return Client;
}(events_1.EventEmitter));
exports.Client = Client;
