"use strict";
/*
 *  This file is part of CoCalc: Copyright © 2020 Sagemath, Inc.
 *  License: AGPLv3 s.t. "Commons Clause" – see LICENSE.md for details
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Changefeed = void 0;
var events_1 = require("events");
var awaiting_1 = require("awaiting");
var misc_1 = require("../../misc");
var Changefeed = /** @class */ (function (_super) {
    __extends(Changefeed, _super);
    function Changefeed(_a) {
        var do_query = _a.do_query, query_cancel = _a.query_cancel, options = _a.options, query = _a.query, table = _a.table;
        var _this = _super.call(this) || this;
        _this.state = "disconnected";
        _this.handle_update_queue = [];
        _this.do_query = do_query;
        _this.query_cancel = query_cancel;
        _this.query = query;
        _this.options = options;
        _this.table = table;
        return _this;
    }
    // Query for state of the table, connects to the
    // changefeed, and return the initial state
    // of the table.  Throws an exception if anything
    // goes wrong.
    Changefeed.prototype.connect = function () {
        return __awaiter(this, void 0, void 0, function () {
            var resp;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.state != "disconnected") {
                            throw Error("can only connect if state is 'disconnected' but it is " + this.state);
                        }
                        this.state = "connecting";
                        return [4 /*yield*/, awaiting_1.callback(this.run_the_query.bind(this))];
                    case 1:
                        resp = _a.sent();
                        if (this.state === "closed") {
                            throw Error("after running query, changefeed state is 'closed'");
                        }
                        if (resp.event === "query_cancel") {
                            throw Error("query-cancel");
                        }
                        if (resp.query == null || resp.query[this.table] == null) {
                            throw Error(this.table + " changefeed init -- no error and no data");
                        }
                        // Successfully completed query
                        this.id = resp.id;
                        this.state = "connected";
                        this.process_queue_next_tick();
                        return [2 /*return*/, resp.query[this.table]];
                }
            });
        });
    };
    // Wait a tick, then process the queue of messages that
    // arrived during initialization.
    Changefeed.prototype.process_queue_next_tick = function () {
        return __awaiter(this, void 0, void 0, function () {
            var x;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, awaiting_1.delay(0)];
                    case 1:
                        _a.sent();
                        while (this.state != "closed" && this.handle_update_queue.length > 0) {
                            x = this.handle_update_queue.shift();
                            if (x != null) {
                                this.handle_update(x.err, x.resp);
                            }
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    Changefeed.prototype.run_the_query = function (cb) {
        var _this = this;
        // This query_function gets called first on the
        // initial query, then repeatedly with each changefeed
        // update. The input function "cb" will be called
        // precisely once, and the method handle_changefeed_update
        // may get called if there are additional
        // changefeed updates.
        var first_time = true;
        this.do_query({
            query: this.query,
            changes: true,
            timeout: 30,
            options: this.options,
            cb: function (err, resp) {
                if (first_time) {
                    cb(err, resp);
                    first_time = false;
                }
                else {
                    _this.handle_update(err, resp);
                }
            },
        });
    };
    Changefeed.prototype.handle_update = function (err, resp) {
        if (this.state != "connected") {
            if (this.state == "closed") {
                // expected, since last updates after query cancel may get through...
                return;
            }
            // This can and does happen when updates appear immediately
            // after the first initial state is set (in run_the_query).
            this.handle_update_queue.push({ err: err, resp: resp });
            return;
        }
        if (resp == null && err == null) {
            err = "resp must not be null for non-error";
        }
        if (err || resp.event === "query_cancel") {
            //if (err) console.warn("closing changefeed due to err", err);
            this.close();
            return;
        }
        if (resp.action == null) {
            // Not a changefeed message.  This happens, e.g., the first time
            // when we use the standby server to get the changefeed.
            return;
        }
        // Return just the new_val/old_val/action part of resp.
        // console.log("resp=", resp);
        var x = {};
        if (resp.new_val) {
            x.new_val = resp.new_val;
        }
        if (resp.old_val) {
            x.old_val = resp.old_val;
        }
        x.action = resp.action;
        this.emit("update", x);
    };
    Changefeed.prototype.close = function () {
        this.state = "closed";
        if (this.id != null) {
            // stop listening for future updates
            this.cancel_query(this.id);
        }
        this.emit("close");
        this.removeAllListeners();
        misc_1.close(this);
        this.state = "closed";
    };
    Changefeed.prototype.cancel_query = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            var err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.query_cancel(id)];
                    case 1:
                        _a.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        err_1 = _a.sent();
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    Changefeed.prototype.get_state = function () {
        return this.state;
    };
    return Changefeed;
}(events_1.EventEmitter));
exports.Changefeed = Changefeed;
//
