"use strict";
/*
 *  This file is part of CoCalc: Copyright © 2020 Sagemath, Inc.
 *  License: AGPLv3 s.t. "Commons Clause" – see LICENSE.md for details
 */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.global_cache_decref = exports.synctable = void 0;
var json_stable_stringify = require("json-stable-stringify");
var awaiting_1 = require("awaiting");
var synctable_1 = require("./synctable");
var synctables = {};
// for debugging; in particular, verify that synctables are freed.
// Do not leave in production; could be slight security risk.
//# window?.synctables = synctables
function synctable(query, options, client, throttle_changes, use_cache) {
    if (use_cache === void 0) { use_cache = true; }
    if (options == null) {
        options = [];
    }
    if (!use_cache) {
        return new synctable_1.SyncTable(query, options, client, throttle_changes);
    }
    var cache_key = json_stable_stringify({
        query: query,
        options: options,
        throttle_changes: throttle_changes,
    });
    var S = synctables[cache_key];
    if (S != null) {
        if (S.get_state() === "connected") {
            // same behavior as newly created synctable
            emit_connected_in_next_tick(S);
        }
    }
    else {
        S = synctables[cache_key] = new synctable_1.SyncTable(query, options, client, throttle_changes);
        S.cache_key = cache_key;
    }
    S.reference_count += 1;
    return S;
}
exports.synctable = synctable;
function emit_connected_in_next_tick(S) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, awaiting_1.delay(0)];
                case 1:
                    _a.sent();
                    if (S.get_state() === "connected") {
                        S.emit("connected");
                    }
                    return [2 /*return*/];
            }
        });
    });
}
function global_cache_decref(S) {
    if (S.reference_count && S.cache_key !== undefined) {
        S.reference_count -= 1;
        if (S.reference_count <= 0) {
            delete synctables[S.cache_key];
            return false; // not in use
        }
        else {
            return true; // still in use
        }
    }
    return false;
}
exports.global_cache_decref = global_cache_decref;
