"use strict";
/*
 *  This file is part of CoCalc: Copyright © 2020 Sagemath, Inc.
 *  License: AGPLv3 s.t. "Commons Clause" – see LICENSE.md for details
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SyncTable = exports.set_debug = void 0;
/*

Variations:  Instead of making this class really complicated
with many different ways to do sync (e.g, changefeeds, project
websockets, unit testing, etc.), we have one single approach via
a Client that has a certain interface.  Then we implement different
Clients that have this interface, in order to support different
ways of orchestrating a SyncTable.

TODO:
 - copy over and update docs from synctable.coffee header.


*/
// CoCalc, Copyright (C) 2018, Sagemath Inc.
// If true, will log to the console a huge amount of
// info about every get/set
var DEBUG = false;
function set_debug(x) {
    DEBUG = x;
}
exports.set_debug = set_debug;
var awaiting_1 = require("awaiting");
var global_cache_1 = require("./global-cache");
var events_1 = require("events");
var immutable_1 = require("immutable");
var underscore_1 = require("underscore");
var async_utils_1 = require("../../async-utils");
var async_wait_1 = require("../../async-wait");
var query_function_1 = require("./query-function");
var misc_1 = require("../../misc");
var schema = require("../../schema");
function is_fatal(err) {
    return err.indexOf("FATAL") != -1;
}
var hof_1 = require("async-await-utils/hof");
var changefeed_1 = require("./changefeed");
var util_1 = require("./util");
var SyncTable = /** @class */ (function (_super) {
    __extends(SyncTable, _super);
    function SyncTable(query, options, client, throttle_changes, coerce_types, no_db_set, project_id) {
        var _this = _super.call(this) || this;
        _this.last_server_time = 0;
        _this.last_save = immutable_1.Map();
        // Which records we have changed (and when, by server time),
        // that haven't been sent to the backend.
        _this.changes = {};
        // The version of each record.
        _this.versions = {};
        // The inital version is only used in the project, where we
        // just assume the clock is right.  If this were totally
        // off/changed, then clients would get confused -- until they
        // close and open the file or refresh their browser.  It might
        // be better to switch to storing the current version number
        // on disk.
        _this.initial_version = new Date().valueOf();
        _this.reference_count = 0;
        // Which fields the user is allowed to set/change.
        // Gets updated during init.
        _this.set_fields = [];
        // Which fields *must* be included in any set query.
        // Also updated during init.
        _this.required_set_fields = {};
        // Coerce types and generally do strong checking of all
        // types using the schema.  Do this unless you have a very
        // good reason not to!
        _this.coerce_types = true;
        // If set, then the table is assumed to be managed
        // entirely externally (using events).
        // This is used by the synctables that are managed
        // entirely by the project (e.g., sync-doc support).
        _this.no_db_set = false;
        _this.last_has_uncommitted_changes = undefined;
        if (coerce_types != undefined) {
            _this.coerce_types = coerce_types;
        }
        if (no_db_set != undefined) {
            _this.no_db_set = no_db_set;
        }
        if (project_id != undefined) {
            _this.project_id = project_id;
        }
        if (misc_1.is_array(query)) {
            throw Error("must be a single query, not array of queries");
        }
        _this.set_state("disconnected");
        _this.changefeed_on_update = _this.changefeed_on_update.bind(_this);
        _this.changefeed_on_close = _this.changefeed_on_close.bind(_this);
        _this.setMaxListeners(100);
        _this.query = util_1.parse_query(query);
        _this.options = options;
        _this.client = client;
        _this.throttle_changes = throttle_changes;
        _this.init_query();
        _this.init_throttle_changes();
        // So only ever runs once at a time.
        _this.save = hof_1.reuseInFlight(_this.save.bind(_this));
        _this.first_connect();
        return _this;
    }
    /* PUBLIC API */
    // is_ready is true if the table has been initialized and not yet closed.
    // It might *not* be currently connected, due to a temporary network
    // disconnect.   When is_ready is true you can read and write to this table,
    // but there is no guarantee things aren't temporarily stale.
    SyncTable.prototype.is_ready = function () {
        return this.value != null && this.state !== "closed";
    };
    /*
    Return true if there are changes to this synctable that
    have NOT been confirmed as saved to the backend database.
    (Always returns false when not yet initialized.)
    */
    SyncTable.prototype.has_uncommitted_changes = function () {
        if (this.state === "closed") {
            return false; // if closed, can't have any uncommitted changes.
        }
        return misc_1.len(this.changes) !== 0;
    };
    /* Gets records from this table.
         - arg = not given: returns everything (as an
                 immutable map from key to obj)
         - arg = array of keys; return map from key to obj
         - arg = single key; returns corresponding object
  
      This is NOT a generic query mechanism.  SyncTable
      is really best thought of as a key:value store!
    */
    SyncTable.prototype.get = function (arg) {
        var e_1, _a;
        this.assert_not_closed("get");
        if (this.value == null) {
            throw Error("table not yet initialized");
        }
        if (arg == null) {
            return this.value;
        }
        if (misc_1.is_array(arg)) {
            var x = immutable_1.Map();
            try {
                for (var arg_1 = __values(arg), arg_1_1 = arg_1.next(); !arg_1_1.done; arg_1_1 = arg_1.next()) {
                    var k = arg_1_1.value;
                    var key = util_1.to_key(k);
                    if (key != null) {
                        x = x.set(key, this.value.get(key));
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (arg_1_1 && !arg_1_1.done && (_a = arg_1.return)) _a.call(arg_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            return x;
        }
        else {
            var key = util_1.to_key(arg);
            if (key != null) {
                return this.value.get(key);
            }
        }
    };
    /* Return the number of records in the table. */
    SyncTable.prototype.size = function () {
        this.assert_not_closed("size");
        if (this.value == null) {
            throw Error("table not yet initialized");
        }
        return this.value.size;
    };
    /*
    Get one record from this table.  Especially useful when
    there is only one record, which is an important special
    case (a so-called "wide" table?.)
    */
    SyncTable.prototype.get_one = function (arg) {
        if (this.value == null) {
            throw Error("table not yet initialized");
        }
        if (arg == null) {
            return this.value.toSeq().first();
        }
        else {
            // get only returns (at most) one object, so it's "get_one".
            return this.get(arg);
        }
    };
    SyncTable.prototype.wait_until_value = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.value != null)
                            return [2 /*return*/];
                        // can't save until server sends state.  We wait.
                        return [4 /*yield*/, async_utils_1.once(this, "init-value-server")];
                    case 1:
                        // can't save until server sends state.  We wait.
                        _a.sent();
                        if (this.value == null) {
                            throw Error("bug -- change should initialize value");
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    /*
    Ensure any unsent changes are sent to the backend.
    When this function returns there are no unsent changes,
    since it keeps calling _save until nothing has changed
    locally.
    */
    SyncTable.prototype.save = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        //console.log("synctable SAVE");
                        this.assert_not_closed("save");
                        if (this.value == null) {
                            // nothing to save yet
                            return [2 /*return*/];
                        }
                        _a.label = 1;
                    case 1:
                        if (!this.has_uncommitted_changes()) return [3 /*break*/, 6];
                        if (!(this.state !== "connected")) return [3 /*break*/, 3];
                        // wait for state change
                        return [4 /*yield*/, async_utils_1.once(this, "state")];
                    case 2:
                        // wait for state change
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        if (!(this.state === "connected")) return [3 /*break*/, 5];
                        return [4 /*yield*/, this._save()];
                    case 4:
                        if (!(_a.sent())) {
                            this.update_has_uncommitted_changes();
                            return [2 /*return*/];
                        }
                        _a.label = 5;
                    case 5: return [3 /*break*/, 1];
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    SyncTable.prototype.update_has_uncommitted_changes = function () {
        var cur = this.has_uncommitted_changes();
        if (cur !== this.last_has_uncommitted_changes) {
            this.emit("has-uncommitted-changes", cur);
            this.last_has_uncommitted_changes = cur;
        }
    };
    /*
    set -- Changes (or creates) one entry in the table.
    The input field changes is either an Immutable.js Map or a JS Object map.
    If changes does not have the primary key then a random record is updated,
    and there *must* be at least one record.  Exception: computed primary
    keys will be computed (see stuff about computed primary keys above).
    The second parameter 'merge' can be one of three values:
      'deep'   : (DEFAULT) deep merges the changes into the record, keep as much info as possible.
      'shallow': shallow merges, replacing keys by corresponding values
      'none'   : do no merging at all -- just replace record completely
    Raises an exception if something goes wrong doing the set.
    Returns updated value otherwise.
  
    DOES NOT causes a save.
  
    NOTE: we always use db schema to ensure types are correct,
    converting if necessary.   This has a performance impact,
    but is worth it for sanity's sake!!!
    */
    SyncTable.prototype.set = function (changes, merge, fire_change_event) {
        var e_2, _a;
        var _this = this;
        if (merge === void 0) { merge = "deep"; }
        if (fire_change_event === void 0) { fire_change_event = true; }
        if (this.value == null) {
            throw Error("can't set until table is initialized");
        }
        if (!immutable_1.Map.isMap(changes)) {
            changes = immutable_1.fromJS(changes);
            if (!misc_1.is_object(changes)) {
                throw Error("type error -- changes must be an immutable.js Map or JS map");
            }
        }
        if (DEBUG) {
            //console.log(`set('${this.table}'): ${JSON.stringify(changes.toJS())}`);
        }
        // For sanity!
        changes = this.do_coerce_types(changes);
        // Ensure that each key is allowed to be set.
        if (this.client_query.set == null) {
            throw Error("users may not set " + this.table);
        }
        var can_set = this.client_query.set.fields;
        changes.map(function (_, k) {
            if (can_set[k] === undefined) {
                throw Error("users may not set " + _this.table + "." + k);
            }
        });
        // Determine the primary key's value
        var key = this.obj_to_key(changes);
        if (key == null) {
            // attempt to compute primary key if it is a computed primary key
            var key0 = this.computed_primary_key(changes);
            key = util_1.to_key(key0);
            if (key == null && this.primary_keys.length === 1) {
                // use a "random" primary key from existing data
                key0 = key = this.value.keySeq().first();
            }
            if (key == null) {
                throw Error("must specify primary key " + this.primary_keys.join(",") + ", have at least one record, or have a computed primary key");
            }
            // Now key is defined
            if (this.primary_keys.length === 1) {
                changes = changes.set(this.primary_keys[0], key0);
            }
            else if (this.primary_keys.length > 1) {
                if (key0 == null) {
                    // to satisfy typescript.
                    throw Error("bug -- computed primary key must be an array");
                }
                var i = 0;
                try {
                    for (var _b = __values(this.primary_keys), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var pk = _c.value;
                        changes = changes.set(pk, key0[i]);
                        i += 1;
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
            }
        }
        // Get the current value
        var cur = this.value.get(key);
        var new_val;
        if (cur == null) {
            // No record with the given primary key.  Require that
            // all the this.required_set_fields are specified, or
            // it will become impossible to sync this table to
            // the backend.
            for (var k in this.required_set_fields) {
                if (changes.get(k) == null) {
                    throw Error("must specify field '" + k + "' for new records");
                }
            }
            // If no current value, then next value is easy -- it equals the current value in all cases.
            new_val = changes;
        }
        else {
            // Use the appropriate merge strategy to get the next val.
            // Fortunately, these are all built into immutable.js!
            switch (merge) {
                case "deep":
                    new_val = cur.mergeDeep(changes);
                    break;
                case "shallow":
                    new_val = cur.merge(changes);
                    break;
                case "none":
                    new_val = changes;
                    break;
                default:
                    throw Error("merge must be one of 'deep', 'shallow', 'none'");
            }
        }
        if (new_val.equals(cur)) {
            // nothing actually changed, so nothing further to do.
            return new_val;
        }
        for (var field in this.required_set_fields) {
            if (!new_val.has(field)) {
                throw Error("missing required set field " + field + " of table " + this.table);
            }
        }
        // Something changed:
        this.value = this.value.set(key, new_val);
        this.changes[key] = this.unique_server_time();
        this.update_has_uncommitted_changes();
        if (this.client.is_project()) {
            // project assigns versions
            var version = this.increment_version(key);
            var obj = new_val.toJS();
            this.emit("versioned-changes", [{ obj: obj, version: version }]);
        }
        else {
            // browser gets them assigned...
            this.null_version(key);
            // also touch to indicate activity and make sure project running,
            // in some cases.
            this.touch_project();
        }
        if (fire_change_event) {
            this.emit_change([key]);
        }
        return new_val;
    };
    SyncTable.prototype.touch_project = function () {
        return __awaiter(this, void 0, void 0, function () {
            var err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(this.project_id != null)) return [3 /*break*/, 4];
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.client.touch_project(this.project_id)];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        err_1 = _a.sent();
                        // not fatal
                        console.warn("touch_project -- ", this.project_id, err_1);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    SyncTable.prototype.close_no_async = function () {
        if (this.state === "closed") {
            // already closed
            return;
        }
        // decrement the reference to this synctable
        if (global_cache_1.global_cache_decref(this)) {
            // close: not zero -- so don't close it yet --
            // still in use by possibly multiple clients
            return;
        }
        if (this.throttled_emit_changes != null) {
            async_utils_1.cancel_scheduled(this.throttled_emit_changes);
            delete this.throttled_emit_changes;
        }
        this.client.removeListener("disconnected", this.disconnected);
        this.close_changefeed();
        this.set_state("closed");
        this.removeAllListeners();
        delete this.value;
    };
    SyncTable.prototype.close = function (fatal) {
        if (fatal === void 0) { fatal = false; }
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.state === "closed") {
                            // already closed
                            return [2 /*return*/];
                        }
                        if (!!fatal) return [3 /*break*/, 2];
                        // do a last attempt at a save (so we don't lose data),
                        // then really close.
                        return [4 /*yield*/, this.save()];
                    case 1:
                        // do a last attempt at a save (so we don't lose data),
                        // then really close.
                        _a.sent(); // attempt last save to database.
                        _a.label = 2;
                    case 2:
                        this.close_no_async();
                        return [2 /*return*/];
                }
            });
        });
    };
    SyncTable.prototype.wait = function (until, timeout) {
        if (timeout === void 0) { timeout = 30; }
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.assert_not_closed("wait");
                        return [4 /*yield*/, async_wait_1.wait({
                                obj: this,
                                until: until,
                                timeout: timeout,
                                change_event: "change-no-throttle",
                            })];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    /* INTERNAL PRIVATE METHODS */
    SyncTable.prototype.first_connect = function () {
        return __awaiter(this, void 0, void 0, function () {
            var err_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.connect()];
                    case 1:
                        _a.sent();
                        this.update_has_uncommitted_changes();
                        return [3 /*break*/, 3];
                    case 2:
                        err_2 = _a.sent();
                        console.warn("synctable: failed to connect (table=" + this.table + "), error=" + err_2, this.query);
                        this.close(true);
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    SyncTable.prototype.set_state = function (state) {
        this.state = state;
        this.emit(state);
    };
    SyncTable.prototype.get_state = function () {
        return this.state;
    };
    SyncTable.prototype.get_table = function () {
        return this.table;
    };
    SyncTable.prototype.set_throttle_changes = function () {
        // No throttling of change events, unless explicitly requested
        // *or* part of the schema.
        if (this.throttle_changes != null)
            return;
        var t = schema.SCHEMA[this.table];
        if (t == null)
            return;
        var u = t.user_query;
        if (u == null)
            return;
        var g = u.get;
        if (g == null)
            return;
        this.throttle_changes = g.throttle_changes;
    };
    SyncTable.prototype.init_throttle_changes = function () {
        var _this = this;
        this.set_throttle_changes();
        if (!this.throttle_changes) {
            this.emit_change = function (changed_keys) {
                _this.emit("change", changed_keys);
                _this.emit("change-no-throttle", changed_keys);
            };
            return;
        }
        // throttle emitting of change events
        var all_changed_keys = {};
        var do_emit_changes = function () {
            //console.log("#{this.table} -- emitting changes", keys(all_changed_keys))
            // CRITICAL: some code depends on emitting change even
            // for the *empty* list of keys!
            // E.g., projects page won't load for new users.  This
            // is the *change* from not loaded to being loaded,
            // which does make sense.
            _this.emit("change", underscore_1.keys(all_changed_keys));
            all_changed_keys = {};
        };
        this.throttled_emit_changes = underscore_1.throttle(do_emit_changes, this.throttle_changes);
        this.emit_change = function (changed_keys) {
            var e_3, _a;
            //console.log("emit_change", changed_keys);
            _this.dbg("emit_change")(changed_keys);
            try {
                //console.log("#{this.table} -- queue changes", changed_keys)
                for (var changed_keys_1 = __values(changed_keys), changed_keys_1_1 = changed_keys_1.next(); !changed_keys_1_1.done; changed_keys_1_1 = changed_keys_1.next()) {
                    var key = changed_keys_1_1.value;
                    all_changed_keys[key] = true;
                }
            }
            catch (e_3_1) { e_3 = { error: e_3_1 }; }
            finally {
                try {
                    if (changed_keys_1_1 && !changed_keys_1_1.done && (_a = changed_keys_1.return)) _a.call(changed_keys_1);
                }
                finally { if (e_3) throw e_3.error; }
            }
            _this.emit("change-no-throttle", changed_keys);
            if (_this.throttled_emit_changes != null) {
                _this.throttled_emit_changes();
            }
        };
    };
    SyncTable.prototype.dbg = function (_f) {
        var _this = this;
        if (!DEBUG) {
            return function () { };
        }
        if (this.client.is_project()) {
            return this.client.dbg("SyncTable('" + JSON.stringify(this.query) + "')." + _f);
        }
        else {
            return function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                console.log.apply(console, __spread(["synctable(\"" + _this.table + "\")." + _f + ": "], args));
            };
        }
    };
    SyncTable.prototype.connect = function () {
        return __awaiter(this, void 0, void 0, function () {
            var dbg;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        dbg = this.dbg("connect");
                        dbg();
                        this.assert_not_closed("connect");
                        if (this.state === "connected") {
                            return [2 /*return*/];
                        }
                        if (!(this.value != null)) return [3 /*break*/, 2];
                        dbg("send off any local unsaved changes first");
                        return [4 /*yield*/, this.save()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        // 2. Now actually setup the changefeed.
                        // (Even if this.no_db_set is set, this still may do
                        // an initial query to the database.  However, the changefeed
                        // does nothing further.)
                        dbg("actually setup changefeed");
                        return [4 /*yield*/, this.create_changefeed()];
                    case 3:
                        _a.sent();
                        dbg("connect should have succeeded");
                        return [2 /*return*/];
                }
            });
        });
    };
    SyncTable.prototype.create_changefeed = function () {
        return __awaiter(this, void 0, void 0, function () {
            var dbg, initval, err_3, changed_keys;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        dbg = this.dbg("create_changefeed");
                        if (this.get_state() == "closed") {
                            dbg("closed so don't do anything ever again");
                            return [2 /*return*/];
                        }
                        dbg("creating changefeed connection...");
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.create_changefeed_connection()];
                    case 2:
                        initval = _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        err_3 = _a.sent();
                        dbg("failed to create changefeed", err_3.toString());
                        // Typically this happens if synctable closed while
                        // creating the connection...
                        this.close();
                        throw err_3;
                    case 4:
                        if (this.state == "closed") {
                            return [2 /*return*/];
                        }
                        dbg("got changefeed, now initializing table data");
                        this.init_changefeed_handlers();
                        changed_keys = this.update_all(initval);
                        dbg("setting state to connected");
                        this.set_state("connected");
                        // NOTE: Can't emit change event until after
                        // switching state to connected, which is why
                        // we do it here.
                        this.emit_change(changed_keys);
                        return [2 /*return*/];
                }
            });
        });
    };
    SyncTable.prototype.close_changefeed = function () {
        if (this.changefeed == null)
            return;
        this.remove_changefeed_handlers();
        this.changefeed.close();
        delete this.changefeed;
    };
    SyncTable.prototype.create_changefeed_connection = function () {
        return __awaiter(this, void 0, void 0, function () {
            var delay_ms, err_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        delay_ms = 500;
                        _a.label = 1;
                    case 1:
                        if (!true) return [3 /*break*/, 8];
                        this.close_changefeed();
                        this.changefeed = new changefeed_1.Changefeed(this.changefeed_options());
                        return [4 /*yield*/, this.wait_until_ready_to_query_db()];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        _a.trys.push([3, 5, , 7]);
                        return [4 /*yield*/, this.changefeed.connect()];
                    case 4: return [2 /*return*/, _a.sent()];
                    case 5:
                        err_4 = _a.sent();
                        if (is_fatal(err_4.toString())) {
                            console.warn("FATAL creating initial changefeed", this.table, err_4);
                            this.close(true);
                            throw err_4;
                        }
                        // This can happen because we might suddenly NOT be ready
                        // to query db immediately after we are ready...
                        console.warn(this.table + " -- failed to connect -- " + err_4 + "; will retry");
                        return [4 /*yield*/, awaiting_1.delay(delay_ms)];
                    case 6:
                        _a.sent();
                        if (delay_ms < 8000) {
                            delay_ms *= 1.3;
                        }
                        return [3 /*break*/, 7];
                    case 7: return [3 /*break*/, 1];
                    case 8: return [2 /*return*/];
                }
            });
        });
    };
    SyncTable.prototype.wait_until_ready_to_query_db = function () {
        return __awaiter(this, void 0, void 0, function () {
            var dbg, client_state;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        dbg = this.dbg("wait_until_ready_to_query_db");
                        if (this.schema.anonymous || this.client.is_project()) {
                            // For anonymous tables (and for project accessing db),
                            // this just means the client is connected.
                            client_state = "connected";
                        }
                        else {
                            // For non-anonymous tables, the client
                            // has to actually be signed in.
                            client_state = "signed_in";
                        }
                        if (this.client["is_" + client_state]()) {
                            dbg("state already achieved -- no need to wait");
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, async_utils_1.once(this.client, client_state)];
                    case 1:
                        _a.sent();
                        dbg("success -- client emited " + client_state);
                        return [2 /*return*/];
                }
            });
        });
    };
    SyncTable.prototype.changefeed_options = function () {
        return {
            do_query: query_function_1.query_function(this.client.query, this.table),
            query_cancel: this.client.query_cancel.bind(this.client),
            options: this.options,
            query: this.query,
            table: this.table,
        };
    };
    SyncTable.prototype.init_changefeed_handlers = function () {
        if (this.changefeed == null)
            return;
        this.changefeed.on("update", this.changefeed_on_update);
        this.changefeed.on("close", this.changefeed_on_close);
    };
    SyncTable.prototype.remove_changefeed_handlers = function () {
        if (this.changefeed == null)
            return;
        this.changefeed.removeListener("update", this.changefeed_on_update);
        this.changefeed.removeListener("close", this.changefeed_on_close);
    };
    SyncTable.prototype.changefeed_on_update = function (change) {
        this.update_change(change);
    };
    SyncTable.prototype.changefeed_on_close = function () {
        this.set_state("disconnected");
        this.create_changefeed();
    };
    SyncTable.prototype.disconnected = function (why) {
        var dbg = this.dbg("disconnected");
        dbg("why=" + why);
        if (this.state === "disconnected") {
            dbg("already disconnected");
            return;
        }
        this.set_state("disconnected");
    };
    SyncTable.prototype.obj_to_key = function (_) {
        // Return string key used in the immutable map in
        // which this table is stored.
        throw Error("this.obj_to_key must be set during initialization");
    };
    SyncTable.prototype.init_query = function () {
        var e_4, _a, e_5, _b, e_6, _c;
        var _this = this;
        // Check that the query is probably valid, and
        // record the table and schema
        var tables = underscore_1.keys(this.query);
        if (misc_1.len(tables) !== 1) {
            throw Error("must query only a single table");
        }
        this.table = tables[0];
        this.schema = schema.SCHEMA[this.table];
        if (this.schema == null) {
            throw Error("unknown schema for table " + this.table);
        }
        if (this.client.is_project()) {
            this.client_query = this.schema.project_query;
        }
        else {
            this.client_query = this.schema.user_query;
        }
        if (this.client_query == null) {
            throw Error("no query schema allowing queries to " + this.table);
        }
        if (!misc_1.is_array(this.query[this.table])) {
            throw Error("must be a multi-document query");
        }
        this.primary_keys = schema.client_db.primary_keys(this.table);
        try {
            // Check that all primary keys are in the query.
            for (var _d = __values(this.primary_keys), _e = _d.next(); !_e.done; _e = _d.next()) {
                var primary_key = _e.value;
                if (this.query[this.table][0][primary_key] === undefined) {
                    throw Error("must include each primary key in query of table '" + this.table + "', but you missed '" + primary_key + "'");
                }
            }
        }
        catch (e_4_1) { e_4 = { error: e_4_1 }; }
        finally {
            try {
                if (_e && !_e.done && (_a = _d.return)) _a.call(_d);
            }
            finally { if (e_4) throw e_4.error; }
        }
        try {
            // Check that all keys in the query are allowed by the schema.
            for (var _g = __values(underscore_1.keys(this.query[this.table][0])), _h = _g.next(); !_h.done; _h = _g.next()) {
                var query_key = _h.value;
                if (this.client_query.get.fields[query_key] === undefined) {
                    throw Error("every key in query of table '" + this.table + "' must" +
                        (" be a valid user get field in the schema but '" + query_key + "' is not"));
                }
            }
        }
        catch (e_5_1) { e_5 = { error: e_5_1 }; }
        finally {
            try {
                if (_h && !_h.done && (_b = _g.return)) _b.call(_g);
            }
            finally { if (e_5) throw e_5.error; }
        }
        // Function this.to_key to extract primary key from object
        if (this.primary_keys.length === 1) {
            // very common case
            var pk_1 = this.primary_keys[0];
            this.obj_to_key = function (obj) {
                if (obj == null) {
                    return;
                }
                if (immutable_1.Map.isMap(obj)) {
                    return util_1.to_key(obj.get(pk_1));
                }
                else {
                    return util_1.to_key(obj[pk_1]);
                }
            };
        }
        else {
            // compound primary key
            this.obj_to_key = function (obj) {
                var e_7, _a, e_8, _b;
                if (obj == null) {
                    return;
                }
                var v = [];
                if (immutable_1.Map.isMap(obj)) {
                    try {
                        for (var _c = __values(_this.primary_keys), _d = _c.next(); !_d.done; _d = _c.next()) {
                            var pk = _d.value;
                            var a = obj.get(pk);
                            if (a == null) {
                                return;
                            }
                            v.push(a);
                        }
                    }
                    catch (e_7_1) { e_7 = { error: e_7_1 }; }
                    finally {
                        try {
                            if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                        }
                        finally { if (e_7) throw e_7.error; }
                    }
                }
                else {
                    try {
                        for (var _e = __values(_this.primary_keys), _g = _e.next(); !_g.done; _g = _e.next()) {
                            var pk = _g.value;
                            var a = obj[pk];
                            if (a == null) {
                                return;
                            }
                            v.push(a);
                        }
                    }
                    catch (e_8_1) { e_8 = { error: e_8_1 }; }
                    finally {
                        try {
                            if (_g && !_g.done && (_b = _e.return)) _b.call(_e);
                        }
                        finally { if (e_8) throw e_8.error; }
                    }
                }
                return util_1.to_key(v);
            };
        }
        if (this.client_query != null && this.client_query.set != null) {
            // Initialize set_fields and required_set_fields.
            var set = this.client_query.set;
            try {
                for (var _j = __values(underscore_1.keys(this.query[this.table][0])), _k = _j.next(); !_k.done; _k = _j.next()) {
                    var field = _k.value;
                    if (set.fields != null && set.fields[field]) {
                        this.set_fields.push(field);
                    }
                    if (set.required_fields != null && set.required_fields[field]) {
                        this.required_set_fields[field] = true;
                    }
                }
            }
            catch (e_6_1) { e_6 = { error: e_6_1 }; }
            finally {
                try {
                    if (_k && !_k.done && (_c = _j.return)) _c.call(_j);
                }
                finally { if (e_6) throw e_6.error; }
            }
        }
    };
    /* Send all unsent changes.
       This function must not be called more than once at a time.
       Returns boolean:
          false -- there are no additional changes to be saved
          true -- new changes appeared during the _save that need to be saved.
    */
    SyncTable.prototype._save = function () {
        return __awaiter(this, void 0, void 0, function () {
            var dbg, query, timed_changes, proposed_keys, changes, key, x, obj, qobj, v, i, _a, _b, primary_key, prev, _c, _d, k, a, b, k, value, err_5, err_6, key, is_done;
            var e_9, _e, e_10, _g, _h;
            return __generator(this, function (_j) {
                switch (_j.label) {
                    case 0:
                        dbg = this.dbg("_save");
                        dbg();
                        if (this.get_state() == "closed")
                            return [2 /*return*/, false];
                        if (this.client_query.set == null) {
                            // Nothing to do -- can never set anything for this table.
                            // There are some tables (e.g., stats) where the remote values
                            // could change while user is offline, and the code below would
                            // result in warnings.
                            return [2 /*return*/, false];
                        }
                        //console.log("_save", this.table);
                        dbg("waiting for network");
                        return [4 /*yield*/, this.wait_until_ready_to_query_db()];
                    case 1:
                        _j.sent();
                        if (this.get_state() == "closed")
                            return [2 /*return*/, false];
                        dbg("waiting for value");
                        return [4 /*yield*/, this.wait_until_value()];
                    case 2:
                        _j.sent();
                        if (this.get_state() == "closed")
                            return [2 /*return*/, false];
                        if (misc_1.len(this.changes) === 0)
                            return [2 /*return*/, false];
                        if (this.value == null) {
                            throw Error("value must not be null");
                        }
                        query = [];
                        timed_changes = [];
                        proposed_keys = {};
                        changes = misc_1.copy(this.changes);
                        //console.log("_save: send ", changes);
                        for (key in this.changes) {
                            if (this.versions[key] === 0) {
                                proposed_keys[key] = true;
                            }
                            x = this.value.get(key);
                            if (x == null) {
                                throw Error("delete is not implemented");
                            }
                            obj = x.toJS();
                            if (!this.no_db_set) {
                                qobj = {};
                                // Set the primary key part:
                                if (this.primary_keys.length === 1) {
                                    qobj[this.primary_keys[0]] = key;
                                }
                                else {
                                    v = JSON.parse(key);
                                    i = 0;
                                    try {
                                        for (_a = (e_9 = void 0, __values(this.primary_keys)), _b = _a.next(); !_b.done; _b = _a.next()) {
                                            primary_key = _b.value;
                                            qobj[primary_key] = v[i];
                                            i += 1;
                                        }
                                    }
                                    catch (e_9_1) { e_9 = { error: e_9_1 }; }
                                    finally {
                                        try {
                                            if (_b && !_b.done && (_e = _a.return)) _e.call(_a);
                                        }
                                        finally { if (e_9) throw e_9.error; }
                                    }
                                }
                                prev = this.last_save.get(key);
                                try {
                                    for (_c = (e_10 = void 0, __values(this.set_fields)), _d = _c.next(); !_d.done; _d = _c.next()) {
                                        k = _d.value;
                                        if (!x.has(k))
                                            continue;
                                        if (prev == null) {
                                            qobj[k] = obj[k];
                                            continue;
                                        }
                                        a = immutable_1.List([x.get(k)]);
                                        b = immutable_1.List([prev.get(k)]);
                                        if (!a.equals(b)) {
                                            qobj[k] = obj[k];
                                        }
                                    }
                                }
                                catch (e_10_1) { e_10 = { error: e_10_1 }; }
                                finally {
                                    try {
                                        if (_d && !_d.done && (_g = _c.return)) _g.call(_c);
                                    }
                                    finally { if (e_10) throw e_10.error; }
                                }
                                for (k in this.required_set_fields) {
                                    if (qobj[k] == null) {
                                        qobj[k] = obj[k];
                                    }
                                }
                                query.push((_h = {}, _h[this.table] = qobj, _h));
                            }
                            timed_changes.push({ obj: obj, time: this.changes[key] });
                        }
                        dbg("sending timed-changes", timed_changes);
                        this.emit("timed-changes", timed_changes);
                        if (!!this.no_db_set) return [3 /*break*/, 6];
                        _j.label = 3;
                    case 3:
                        _j.trys.push([3, 5, , 6]);
                        value = this.value;
                        dbg("doing database query");
                        return [4 /*yield*/, async_utils_1.callback2(this.client.query, {
                                query: query,
                                options: [{ set: true }],
                                timeout: 120,
                            })];
                    case 4:
                        _j.sent();
                        this.last_save = value; // success -- don't have to save this stuff anymore...
                        return [3 /*break*/, 6];
                    case 5:
                        err_5 = _j.sent();
                        dbg("db query failed", err_5);
                        if (is_fatal(err_5.toString())) {
                            console.warn("FATAL doing set", this.table, err_5);
                            this.close(true);
                            throw err_5;
                        }
                        // NOTE: we do not show entire log since the number
                        // of entries in the query can be very large and just
                        // converting them all to text could use a lot of memory (?).
                        console.warn("_save('" + this.table + "') set query error:", err_5, " queries: ", query[0], "...", query.length - 1, " omitted");
                        return [2 /*return*/, true];
                    case 6:
                        if (this.get_state() == "closed")
                            return [2 /*return*/, false];
                        if (this.value == null) {
                            // should not happen
                            return [2 /*return*/, false];
                        }
                        if (!this.no_db_set) return [3 /*break*/, 10];
                        _j.label = 7;
                    case 7:
                        _j.trys.push([7, 9, , 10]);
                        dbg("waiting until versions are updated");
                        return [4 /*yield*/, this.wait_until_versions_are_updated(proposed_keys, 5000)];
                    case 8:
                        _j.sent();
                        return [3 /*break*/, 10];
                    case 9:
                        err_6 = _j.sent();
                        dbg("waiting for versions timed out / failed");
                        // took too long -- try again to send and receive changes.
                        return [2 /*return*/, true];
                    case 10:
                        dbg("Record that we successfully sent these changes");
                        for (key in changes) {
                            if (changes[key] == this.changes[key]) {
                                delete this.changes[key];
                            }
                        }
                        this.update_has_uncommitted_changes();
                        is_done = misc_1.len(this.changes) === 0;
                        dbg("done? ", is_done);
                        return [2 /*return*/, !is_done];
                }
            });
        });
    };
    SyncTable.prototype.wait_until_versions_are_updated = function (proposed_keys, timeout_ms) {
        return __awaiter(this, void 0, void 0, function () {
            var start_ms, key, elapsed_ms, keys_2, keys_1, keys_1_1, key;
            var e_11, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        start_ms = new Date().valueOf();
                        _b.label = 1;
                    case 1:
                        if (!(misc_1.len(proposed_keys) > 0)) return [3 /*break*/, 4];
                        for (key in proposed_keys) {
                            if (this.versions[key] > 0) {
                                delete proposed_keys[key];
                            }
                        }
                        if (!(misc_1.len(proposed_keys) > 0)) return [3 /*break*/, 3];
                        elapsed_ms = new Date().valueOf() - start_ms;
                        return [4 /*yield*/, async_utils_1.once(this, "increased-versions", timeout_ms - elapsed_ms)];
                    case 2:
                        keys_2 = _b.sent();
                        try {
                            for (keys_1 = (e_11 = void 0, __values(keys_2)), keys_1_1 = keys_1.next(); !keys_1_1.done; keys_1_1 = keys_1.next()) {
                                key = keys_1_1.value;
                                delete proposed_keys[key];
                            }
                        }
                        catch (e_11_1) { e_11 = { error: e_11_1 }; }
                        finally {
                            try {
                                if (keys_1_1 && !keys_1_1.done && (_a = keys_1.return)) _a.call(keys_1);
                            }
                            finally { if (e_11) throw e_11.error; }
                        }
                        _b.label = 3;
                    case 3: return [3 /*break*/, 1];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    // Return modified immutable Map, with all types coerced to be
    // as specified in the schema, if possible, or throw an exception.
    SyncTable.prototype.do_coerce_types = function (changes) {
        var _this = this;
        if (!this.coerce_types) {
            // no-op if coerce_types isn't set.
            return changes;
        }
        var t = schema.SCHEMA[this.table];
        if (t == null) {
            throw Error("Missing schema for table " + this.table);
        }
        var fields = misc_1.copy(t.fields);
        if (fields == null) {
            throw Error("Missing fields part of schema for table " + this.table);
        }
        var specs;
        if (t.virtual != null) {
            if (t.virtual === true) {
                throw Error("t.virtual can't be true for " + this.table);
            }
            var x = schema.SCHEMA[t.virtual];
            if (x == null) {
                throw Error("invalid virtual table spec for " + this.table);
            }
            specs = misc_1.copy(x.fields);
            if (specs == null) {
                throw Error("invalid virtual table spec for " + this.table);
            }
        }
        else {
            specs = fields;
        }
        if (typeof this.query != "string") {
            // explicit query (not just from schema)
            var x = this.query[this.table];
            if (misc_1.is_array(x)) {
                x = x[0];
            }
            for (var k in fields) {
                if (x[k] === undefined) {
                    delete fields[k];
                }
            }
        }
        return immutable_1.Map(changes.map(function (value, field) {
            if (typeof field !== "string") {
                // satisfy typescript.
                return;
            }
            if (value == null) {
                // do not coerce null types
                return value;
            }
            if (fields[field] == null) {
                //console.warn(changes, fields);
                throw Error("Cannot coerce: no field '" + field + "' in table " + _this.table);
            }
            var spec = specs[field];
            var desired = spec.type || spec.pg_type;
            if (desired == null) {
                throw Error("Cannot coerce: no type info for field " + field);
            }
            desired = desired.toLowerCase();
            var actual = typeof value;
            if (desired === actual) {
                return value;
            }
            // We can add more or less later...
            if (desired === "string" || desired.slice(0, 4) === "char") {
                if (actual !== "string") {
                    // ensure is a string
                    return "" + value;
                }
                return value;
            }
            if (desired === "timestamp") {
                if (!(value instanceof Date)) {
                    // make it a Date object. (usually converting from string rep)
                    return new Date(value);
                }
                return value;
            }
            if (desired === "integer") {
                // always fine to do this -- will round floats, fix strings, etc.
                return parseInt(value);
            }
            if (desired === "number") {
                // actual wasn't number, so parse:
                return parseFloat(value);
            }
            if (desired === "array") {
                if (!immutable_1.List.isList(value)) {
                    value = immutable_1.fromJS(value);
                    if (!immutable_1.List.isList(value)) {
                        throw Error("field " + field + " of table " + _this.table + " (value=" + changes.get(field) + ") must convert to an immutable.js List");
                    }
                }
                return value;
            }
            if (desired === "map") {
                if (!immutable_1.Map.isMap(value)) {
                    value = immutable_1.fromJS(value);
                    if (!immutable_1.Map.isMap(value)) {
                        throw Error("field " + field + " of table " + _this.table + " (value=" + changes.get(field) + ") must convert to an immutable.js Map");
                    }
                }
                return value;
            }
            if (desired === "boolean") {
                // actual wasn't boolean, so coerce.
                return !!value;
            }
            if (desired === "uuid") {
                misc_1.assert_uuid(value);
                return value;
            }
            return value;
        }));
    };
    /*
    Handle an update of all records from the database.
    This happens on initialization, and also if we
    disconnect and reconnect.
    */
    SyncTable.prototype.update_all = function (v) {
        //const dbg = this.dbg("update_all");
        var e_12, _a;
        var _this = this;
        if (this.state === "closed") {
            // nothing to do -- just ignore updates from db
            throw Error("makes no sense to do update_all when state is closed.");
        }
        this.emit("before-change");
        // Restructure the array of records in v as a mapping
        // from the primary key to the corresponding record.
        var x = {};
        try {
            for (var v_1 = __values(v), v_1_1 = v_1.next(); !v_1_1.done; v_1_1 = v_1.next()) {
                var y = v_1_1.value;
                var key = this.obj_to_key(y);
                if (key != null) {
                    x[key] = y;
                    // initialize all version numbers
                    this.versions[key] = this.initial_version;
                }
            }
        }
        catch (e_12_1) { e_12 = { error: e_12_1 }; }
        finally {
            try {
                if (v_1_1 && !v_1_1.done && (_a = v_1.return)) _a.call(v_1);
            }
            finally { if (e_12) throw e_12.error; }
        }
        var changed_keys = underscore_1.keys(x); // of course all keys have been changed.
        this.emit("increased-versions", changed_keys);
        this.value = immutable_1.fromJS(x);
        if (this.value == null) {
            throw Error("bug");
        }
        this.last_save = this.value;
        if (this.coerce_types) {
            // Ensure all values are properly coerced, as specified
            // in the database schema.  This is important, e.g., since
            // when mocking the client db query, JSON is involved and
            // timestamps are not parsed to Date objects.
            this.value = this.value.map(function (val, _) {
                if (val == null) {
                    throw Error("val must not be null");
                }
                return _this.do_coerce_types(val);
            });
        }
        // It's possibly that nothing changed (e.g., typical case
        // on reconnect!) so we check.
        // If something really did change, we set the server
        // state to what we just got, and
        // also inform listeners of which records changed (by giving keys).
        //console.log("update_all: changed_keys=", changed_keys)
        if (this.state === "connected") {
            // When not yet connected, initial change is emitted
            // by function that sets up the changefeed.  We are
            // connected here, so we are responsible for emitting
            // this change.
            this.emit_change(changed_keys);
        }
        this.emit("init-value-server");
        return changed_keys;
    };
    SyncTable.prototype.initial_version_for_browser_client = function () {
        var _this = this;
        if (this.value == null) {
            throw Error("value must not be null");
        }
        var x = [];
        this.value.forEach(function (val, key) {
            if (val == null) {
                throw Error("val must be non-null");
            }
            var obj = val.toJS();
            if (obj == null) {
                throw Error("obj must be non-null");
            }
            if (key == null) {
                throw Error("key must not be null");
            }
            var version = _this.versions[key];
            if (version == null) {
                throw Error("version must not be null");
            }
            x.push({ obj: obj, version: version });
        });
        return x;
    };
    SyncTable.prototype.init_browser_client = function (changes) {
        var _this = this;
        var dbg = this.dbg("init_browser_client");
        dbg("applying " + changes.length + " versioned changes");
        // The value before doing init (which happens precisely when project
        // synctable is reset). See note below.
        var before = this.value;
        var received_keys = this.apply_changes_to_browser_client(changes);
        if (before != null) {
            before.forEach(function (_, key) {
                if (key == null || received_keys[key])
                    return; // received as part of init
                if (_this.changes[key] && _this.versions[key] == 0)
                    return; // not event sent yet
                // This key was known and confirmed sent before init, but
                // didn't get sent back this time.  So it was lost somehow,
                // e.g., due to not getting saved to the database and the project
                // (or table in the project) getting restarted.
                dbg("found lost: key=" + key);
                // So we will try to send out it again.
                if (!_this.changes[key]) {
                    _this.changes[key] = _this.unique_server_time();
                    _this.update_has_uncommitted_changes();
                }
                // So we don't view it as having any known version
                // assigned by project, since the project lost it.
                _this.null_version(key);
            });
            if (misc_1.len(this.changes) > 0) {
                this.save(); // kick off a save of our unsaved lost work back to the project.
            }
        }
        /*
        NOTE: The problem solved here is the following.  Imagine the project
        synctable is killed, and it has acknowledge a change C from a
        web browser client, but has NOT saved that change to the central
        postgreSQL database (or someday, maybe a local SQLite database).
        Then when the project synctable is resurrected, it uses the database
        for its initial state, and it knows nothing about C.  The
        browser thinks that C has been successfully written and broadcast
        to everybody, so the browser doesn't send C again.  The result is
        that the browser and the project would be forever out of sync.
        Note that we only care about lost changes that some browser knows
        about -- if no browser knows about them, then the fact they are
        lost won't break sync.  Also, for file editing, data is regularly
        saved to disk, so if the browser sends a change that is lost due to
        the project being killed before writing to the database, then the
        browser terminates too, then that change is completely lost.  However,
        everybody will start again with at least the last version of the file
        **saved to disk,** which is basically what people may expect as a
        worst case.
    
        The solution to the above problem is to look at what key:value pairs
        we know about that the project didn't just send back to us.  If there
        are any that were reported as committed, but they vanished, then we
        set them as unsent and send them again.
        */
    };
    SyncTable.prototype.apply_changes_to_browser_client = function (changes) {
        var e_13, _a;
        var dbg = this.dbg("apply_changes_to_browser_client");
        dbg("got ", changes.length, "changes");
        this.assert_not_closed("apply_changes_to_browser_client");
        if (this.value == null) {
            // initializing the synctable for the first time.
            this.value = immutable_1.Map();
        }
        this.emit("before-change");
        var changed_keys = [];
        var increased_versions = [];
        var received_keys = {};
        try {
            for (var changes_1 = __values(changes), changes_1_1 = changes_1.next(); !changes_1_1.done; changes_1_1 = changes_1.next()) {
                var change = changes_1_1.value;
                var obj = change.obj, version = change.version;
                var new_val = this.do_coerce_types(immutable_1.fromJS(obj));
                var key = this.obj_to_key(new_val);
                if (key == null) {
                    throw Error("object results in null key");
                }
                received_keys[key] = true;
                var cur_version = this.versions[key] ? this.versions[key] : 0;
                if (cur_version > version) {
                    // nothing further to do.
                    continue;
                }
                if (this.handle_new_val(new_val, undefined, "insert", false)) {
                    // really did make a change.
                    changed_keys.push(key);
                }
                // Update our version number to the newer version.
                this.versions[key] = version;
                increased_versions.push(key);
            }
        }
        catch (e_13_1) { e_13 = { error: e_13_1 }; }
        finally {
            try {
                if (changes_1_1 && !changes_1_1.done && (_a = changes_1.return)) _a.call(changes_1);
            }
            finally { if (e_13) throw e_13.error; }
        }
        if (increased_versions.length > 0) {
            this.emit("increased-versions", increased_versions);
        }
        if (changed_keys.length > 0) {
            this.emit_change(changed_keys);
        }
        return received_keys;
    };
    SyncTable.prototype.apply_changes_from_browser_client = function (changes) {
        var e_14, _a;
        var dbg = this.dbg("apply_changes_from_browser_client");
        dbg("project <-- changes -- client", JSON.stringify(changes));
        var changed_keys = [];
        var versioned_changes = [];
        try {
            for (var changes_2 = __values(changes), changes_2_1 = changes_2.next(); !changes_2_1.done; changes_2_1 = changes_2.next()) {
                var change = changes_2_1.value;
                var obj = change.obj, time = change.time;
                if (obj == null) {
                    throw Error("obj must not be null");
                }
                var new_val = this.do_coerce_types(immutable_1.fromJS(obj));
                var key = this.obj_to_key(new_val); // must have been coerced!
                if (key == null) {
                    throw Error("object results in null key");
                }
                var cur_time = this.changes[key];
                if (cur_time != null && cur_time > time) {
                    dbg("already have a more recent version");
                    // We already have a more recent update to this object.
                    // We push that new version out again, just in case.
                    if (this.value == null) {
                        throw Error("value must not be null");
                    }
                    var obj_1 = this.value.get(key);
                    if (obj_1 == null) {
                        throw Error("there must be an object in this.value with key " + key);
                    }
                    obj_1 = obj_1.toJS();
                    var version = this.versions[key];
                    if (version == null) {
                        throw Error("object with key " + key + " must have a version");
                    }
                    versioned_changes.push({ obj: obj_1, version: version });
                    continue;
                }
                if (this.handle_new_val(new_val, undefined, "insert", false)) {
                    var version = this.increment_version(key);
                    this.changes[key] = time;
                    this.update_has_uncommitted_changes();
                    versioned_changes.push({ obj: new_val.toJS(), version: version });
                    changed_keys.push(key);
                }
            }
        }
        catch (e_14_1) { e_14 = { error: e_14_1 }; }
        finally {
            try {
                if (changes_2_1 && !changes_2_1.done && (_a = changes_2.return)) _a.call(changes_2);
            }
            finally { if (e_14) throw e_14.error; }
        }
        if (changed_keys.length > 0) {
            this.emit_change(changed_keys);
        }
        if (versioned_changes.length > 0) {
            this.emit("versioned-changes", versioned_changes);
        }
        dbg("project -- versioned --> clients", JSON.stringify(versioned_changes));
    };
    SyncTable.prototype.increment_version = function (key) {
        if (this.versions[key] == null) {
            this.versions[key] = this.initial_version;
        }
        else {
            this.versions[key] += 1;
        }
        this.emit("increased-versions", [key]);
        return this.versions[key];
    };
    SyncTable.prototype.null_version = function (key) {
        this.versions[key] = 0;
    };
    /*
    Apply one incoming change from the database to the
    in-memory table.
    */
    SyncTable.prototype.update_change = function (change) {
        if (this.state === "closed") {
            // We might get a few more updates even after
            // canceling the changefeed, so we just ignore them.
            return;
        }
        if (this.value == null) {
            console.warn("update_change(" + this.table + "): ignored");
            return;
        }
        this.emit("before-change");
        var changed_keys = [];
        var key = this.handle_new_val(change.new_val, change.old_val, change.action, this.coerce_types);
        if (key != null) {
            changed_keys.push(key);
        }
        //console.log("update_change: changed_keys=", changed_keys)
        if (changed_keys.length > 0) {
            //console.log("_update_change: change")
            this.emit_change(changed_keys);
        }
    };
    // Returns current time (in ms since epoch) on server,
    // but if there are multiple requests at the same time,
    // the clock is artificially incremented to ensure uniqueness.
    // Also, this time is thus always strictly increasing.
    SyncTable.prototype.unique_server_time = function () {
        var tm = this.client.server_time().valueOf();
        if (tm <= this.last_server_time) {
            tm = this.last_server_time + 1;
        }
        this.last_server_time = tm;
        return tm;
    };
    // - returns key only if obj actually changed things.
    SyncTable.prototype.handle_new_val = function (new_val, old_val, action, coerce) {
        if (this.value == null) {
            // to satisfy typescript.
            throw Error("value must be initialized");
        }
        if (action === "delete") {
            old_val = immutable_1.fromJS(old_val);
            if (old_val == null) {
                throw Error("old_val must not be null for delete action");
            }
            if (coerce && this.coerce_types) {
                old_val = this.do_coerce_types(old_val);
            }
            var key_1 = this.obj_to_key(old_val);
            if (key_1 == null || !this.value.has(key_1)) {
                return; // already gone
            }
            this.value = this.value.delete(key_1);
            return key_1;
        }
        new_val = immutable_1.fromJS(new_val);
        if (new_val == null) {
            throw Error("new_val must not be null for insert or update action");
        }
        if (coerce && this.coerce_types) {
            new_val = this.do_coerce_types(new_val);
        }
        var key = this.obj_to_key(new_val);
        if (key == null) {
            // This means the primary key is null or missing, which
            // shouldn't happen.  Maybe it could in some edge case.
            // For now, we shouldn't let this break everything, so:
            console.warn(this.table, "handle_new_val: ignoring invalid new_val ", new_val);
            return undefined;
            // throw Error("key must not be null");
        }
        var cur_val = this.value.get(key);
        if (action === "update" && cur_val != null) {
            // For update actions, we shallow *merge* in the change.
            // For insert action, we just replace the whole thing.
            new_val = cur_val.merge(new_val);
        }
        if (!new_val.equals(cur_val)) {
            this.value = this.value.set(key, new_val);
            return key;
        }
        return undefined;
    };
    /*
    obj is an immutable.js Map without the primary key
    set.  If the database schema defines a way to compute
    the primary key from other keys, try to use it here.
    This function returns the computed primary key (array or string)
    if it works, and returns undefined otherwise.
    */
    SyncTable.prototype.computed_primary_key = function (obj) {
        var e_15, _a;
        var f;
        if (this.primary_keys.length === 1) {
            f = this.client_query.set.fields[this.primary_keys[0]];
            if (typeof f === "function") {
                return f(obj.toJS(), schema.client_db);
            }
            else {
                return;
            }
        }
        else {
            var v = [];
            try {
                for (var _b = __values(this.primary_keys), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var pk = _c.value;
                    f = this.client_query.set.fields[pk];
                    if (typeof f === "function") {
                        v.push(f(obj.toJS(), schema.client_db));
                    }
                    else {
                        return;
                    }
                }
            }
            catch (e_15_1) { e_15 = { error: e_15_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_15) throw e_15.error; }
            }
            return v;
        }
    };
    SyncTable.prototype.assert_not_closed = function (desc) {
        if (this.state === "closed") {
            //console.trace();
            throw Error("the synctable \"" + this.table + "\" must not be closed -- " + desc);
        }
    };
    // **WARNING:** Right now this *barely* works at all... due to
    // barely being implemented since I mostly haven't needed it.
    // It will delete the object from the database, but if some
    // client still has the object, they can end up just writing
    // it back.
    SyncTable.prototype.delete = function (obj) {
        return __awaiter(this, void 0, void 0, function () {
            var query, options;
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        query = (_a = {}, _a[this.table] = obj, _a);
                        options = [{ delete: true }];
                        return [4 /*yield*/, async_utils_1.callback2(this.client.query, { query: query, options: options })];
                    case 1:
                        _b.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return SyncTable;
}(events_1.EventEmitter));
exports.SyncTable = SyncTable;
