"use strict";
/*
 *  This file is part of CoCalc: Copyright © 2020 Sagemath, Inc.
 *  License: AGPLv3 s.t. "Commons Clause" – see LICENSE.md for details
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.ClientTest = void 0;
/*
Minimal client class that we use for testing.
*/
var events_1 = require("events");
var misc_1 = require("../../../misc");
var ClientTest = /** @class */ (function (_super) {
    __extends(ClientTest, _super);
    function ClientTest(initial_get_query) {
        var _this = _super.call(this) || this;
        _this.set_queries = [];
        _this.initial_get_query = initial_get_query;
        misc_1.bind_methods(_this, ["query", "dbg", "query_cancel"]);
        return _this;
    }
    ClientTest.prototype.is_project = function () {
        return false;
    };
    ClientTest.prototype.is_connected = function () {
        return true;
    };
    ClientTest.prototype.is_signed_in = function () {
        return true;
    };
    ClientTest.prototype.dbg = function (_) {
        return console.log;
    };
    ClientTest.prototype.query = function (opts) {
        var _a;
        if (opts.options && opts.options.length === 1 && opts.options[0].set) {
            // set query
            this.set_queries.push(opts);
            opts.cb();
        }
        else {
            // get query -- returns predetermined result
            var table = misc_1.keys(opts.query)[0];
            opts.cb(undefined, { query: (_a = {}, _a[table] = this.initial_get_query, _a) });
        }
    };
    ClientTest.prototype.query_cancel = function (_) { };
    ClientTest.prototype.alert_message = function (_) { };
    ClientTest.prototype.server_time = function () {
        return new Date();
    };
    ClientTest.prototype.touch_project = function (_) { };
    return ClientTest;
}(events_1.EventEmitter));
exports.ClientTest = ClientTest;
