"use strict";
/*
 *  This file is part of CoCalc: Copyright © 2020 Sagemath, Inc.
 *  License: AGPLv3 s.t. "Commons Clause" – see LICENSE.md for details
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.is_set = exports.is_date = exports.is_object = exports.is_string = exports.is_integer = exports.is_array = void 0;
function is_array(obj) {
    return Object.prototype.toString.call(obj) === "[object Array]";
}
exports.is_array = is_array;
function is_integer(obj) {
    var _a, _b;
    return (_b = (_a = Number.isInteger) === null || _a === void 0 ? void 0 : _a.call(Number, obj)) !== null && _b !== void 0 ? _b : (typeof obj
        === "number" && obj
        % 1 === 0);
}
exports.is_integer = is_integer;
function is_string(obj) {
    return typeof obj === "string";
}
exports.is_string = is_string;
// An object -- this is more constraining that typeof(obj) == 'object', e.g., it does
// NOT include Date.
function is_object(obj) {
    return Object.prototype.toString.call(obj) === "[object Object]";
}
exports.is_object = is_object;
function is_date(obj) {
    return obj instanceof Date;
}
exports.is_date = is_date;
function is_set(obj) {
    return Object.prototype.toString.call(obj) === "[object Set]";
}
exports.is_set = is_set;
